#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "barrierproxy4xi.py">
#<abstract4xi abstract = "provides BarrierProxy4Xi class"/>
#<refer4xi reference = "synchronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
#

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'BarrierProxy4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # imported-as ones 
    from time import time as _time, sleep as _sleep        
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:
    from multiprocessing import managers
except:
    print("barrierproxy4xi.py *** failed in from multiprocessing import managers ***") 
try:
    from multiprocessing.managers import BarrierProxy
except:
    print("barrierproxy4xi.py *** failed in multiprocessing.managers import BarrierProxy ***")         
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from baseproxy4xi import BaseProxy4Xi
from condition4xi import Condition4Xi
from lock4xi import Lock4Xi
from reason_object4xi import reason_object4xi
from register_after_fork4xi import register_after_fork4xi
from sense_object4xi import sense_object4xi
from timeout4xi import omega2timeout4xi
from print4xi import print4xi
from time4xi import time4xi    
#"
#/>

                

# =================================================================================================
#<class4xi class = "BarrierProxy4Xi" base = "threading.Barrier" child = "None" synopsis = "offers barrier proxy services" usage = "
#    managers.py:
#        SyncManager.register('Barrier', threading.Barrier, BarrierProxy)
# 
#    syncmanager4xi.py:
#        SyncManager4Xi.register('BarrierProxy4Xi', threading.Barrier, BarrierProxy4Xi)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
      
class BarrierProxy4Xi(BaseProxy4Xi):
    '''
    BarrierProxy4Xi class offers barrier proxy services  
    '''
  
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('__getattribute__', 'wait', 'abort', 'reset', 'sense', 'reason', 'ace')         
    #"
    #/>
                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-BarrierProxy4Xi" usage = "initializes with( self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        BarrierProxy4Xi method __init__: initializes with( self) 
        '''
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)
        # -----------------------------------------------------------------------------------------
        class2print = "BarrierProxy4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/2a) started" + "; init-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        
        message2print = "{(Step 1/2b) borning" + "; barrierproxy2xi-of-BarrierProxy4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        message2print = "{(Step 1/2c) inheriting" + "; BaseProxy4Xi-inheriting-by-barrierproxy2xi-of-BarrierProxy4Xi: " + str(BaseProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        

                        
        # -----------------------------------------------------------------------------------------
        # (Step 2/2)
        # -----------------------------------------------------------------------------------------
           
        message2print = "{(Step 2/2a) activated" + "; barrierproxy2xi-of-BarrierProxy4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
         
        message2print = "{(Step 2/2b) inherited" + "; BaseProxy4Xi-inherited-by-barrierproxy2xi-of-BarrierProxy4Xi: " + str(BaseProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{(Step 2/2c) returning" + "; init-of-BarrierProxy4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                
                                   
    #</methodize4xi>
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "wait-of-BarrierProxy4Xi" usage = "waits with (self, timeout=None)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def wait(self, timeout=None):
        '''
        BarrierProxy4Xi method wait: wait with (self, timeout)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)
        # -----------------------------------------------------------------------------------------    
        class2print = "BarrierProxy4Xi"
        method2print = "wait"
        
        message2print = "{(Step 1/2a) started" + "; wait-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{(Step 1/2b) passed" + "; timeout-passed-to-wait-of-BarrierProxy4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        

        # -----------------------------------------------------------------------------------------
        # (Step 2/2)
        # -----------------------------------------------------------------------------------------                     
        message2print = "{returning" + "; callmethod-returning-by-wait-of-BarrierProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        return self._callmethod('wait', (timeout,))                
          
    #</methodize4xi>

                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "abort-of-BarrierProxy4Xi" usage = "aborts with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def abort(self):
        '''
        BarrierProxy4Xi method abort: abort with (self)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)
        # -----------------------------------------------------------------------------------------    
        class2print = "BarrierProxy4Xi"
        method2print = "abort"
        
        message2print = "{(Step 1/2a) started" + "; abort-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

 
        # -----------------------------------------------------------------------------------------
        # (Step 2/2)
        # -----------------------------------------------------------------------------------------                     
        message2print = "{returning" + "; callmethod-returning-by-abort-of-BarrierProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        return self._callmethod('abort')       
          
    #</methodize4xi>            
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reset-of-BarrierProxy4Xi" usage = "resets with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reset(self):
        '''
        BarrierProxy4Xi method reset: reset with (self)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)
        # -----------------------------------------------------------------------------------------    
        class2print = "BarrierProxy4Xi"
        method2print = "reset"
        
        message2print = "{(Step 1/2a) started" + "; reset-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

 
        # -----------------------------------------------------------------------------------------
        # (Step 2/2)
        # -----------------------------------------------------------------------------------------                     
        message2print = "{returning" + "; callmethod-returning-by-reset-of-BarrierProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        return self._callmethod('reset')
          
    #</methodize4xi>
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "parties-property-of-BarrierProxy4Xi" usage = "property">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def parties(self):
        '''
        BarrierProxy4Xi property parties
        '''

        return self._callmethod('__getattribute__', ('parties',))
          
    #</methodize4xi>
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "n_waiting-property-of-BarrierProxy4Xi" usage = "property">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def n_waiting(self):
        '''
        BarrierProxy4Xi property n_waiting
        '''

        return self._callmethod('__getattribute__', ('n_waiting',))
          
    #</methodize4xi>
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "broken-property-of-BarrierProxy4Xi" usage = "property">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def broken(self):
        '''
        BarrierProxy4Xi property broken
        '''

        return self._callmethod('__getattribute__', ('broken',))
          
    #</methodize4xi>            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-BarrierProxy4Xi" usage = "senses BarrierProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses BarrierProxy4Xi class objects
        '''
          
        
        class2print = 'BarrierProxy4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; barrierproxy4xi-sensing-by-sense-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                      
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-BarrierProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-barrierproxy2xi'] = object
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-BarrierProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        
      
        message2print = "{sensed" + "; barrierproxy4xi-sensed-by-sense-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-BarrierProxy4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-BarrierProxy4Xi" usage = "reasons BarrierProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons BarrierProxy4Xi class objects
        '''
                
        
        class2print = 'BarrierProxy4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; BarrierProxy4Xi-reasoning-by-reason-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-BarrierProxy4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; BarrierProxy4Xi-reasoned-by-reason-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-BarrierProxy4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-BarrierProxy4Xi" usage = "aces BarrierProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces BarrierProxy4Xi class objects 
        '''
                
        
        
        class2print = 'BarrierProxy4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-BarrierProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; BarrierProxy4Xi-acing-by-ace-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-BarrierProxy4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; BarrierProxy4Xi-aced-by-ace-of-BarrierProxy4Xi: " + str(BarrierProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-BarrierProxy4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of barrierproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

